package com.example.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.http.MediaType;
import org.springframework.security.oauth2.client.web.reactive.function.client.ServerOAuth2AuthorizedClientExchangeFilterFunction;
import org.springframework.web.reactive.function.client.WebClient;

@SpringBootApplication
public class DemoApplication implements CommandLineRunner {

    @Autowired private WebClient client;

	public static void main(String[] args) {
		SpringApplication.run(DemoApplication.class, args).close();
	}

	@Override
	public void run(String... args) {
		client
			.get()
			.uri("http://localhost/secured/endpoint")
			.attributes(
				ServerOAuth2AuthorizedClientExchangeFilterFunction.clientRegistrationId("keycloak"))
			.accept(MediaType.TEXT_PLAIN)
			.retrieve()
			.bodyToMono(String.class)
			.subscribe();
	}
}
